//---------------------------------------------------------------------------

#ifndef MultimediaTimerH
#define MultimediaTimerH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include "mmsystem.h"
//---------------------------------------------------------------------------
void CALLBACK TimerProcOneShot( UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2 ) ;
void CALLBACK TimerProcPeriodic( UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2 ) ;
//---------------------------------------------------------------------------
class PACKAGE TMultimediaTimer : public TComponent
{
private:
	UINT mEventType, mTimerID ;
	TMultiReadExclusiveWriteSynchronizer *mSynchronizer ;
	int mPeriodMin, mPeriodMax ;
	bool mDisabled, mDesigning ;
	bool mActive, mPrevActive ;
	int mInterval, mResolution ;
	bool mIsPeriodic ;
	TNotifyEvent FOnTimer ;
	bool __fastcall GetActive() ;
	void __fastcall SetActive(bool aValue) ;
	int __fastcall GetInterval() ;
	void __fastcall SetInterval(int aValue) ;
	int __fastcall GetIsPeriodic() ;
	void __fastcall SetIsPeriodic(bool aValue) ;
	int __fastcall GetResolution() ;
	void __fastcall SetResolution(int value) ;


protected:
	friend void CALLBACK TimerProcOneShot( UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2 ) ;
	friend void CALLBACK TimerProcPeriodic( UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2 ) ;
	virtual void __fastcall TimerRoutine() ;


public:
	__fastcall TMultimediaTimer(TComponent* Owner) ;
	__fastcall ~TMultimediaTimer() ;

	
__published:
	__property bool Active  = { read=GetActive, write=SetActive } ;
	__property int Interval  = { read=mInterval, write=SetInterval } ;
	__property bool IsPeriodic  = { read=mIsPeriodic, write=SetIsPeriodic, default=true } ;
	__property int Resolution  = { read=mResolution, write=SetResolution } ;
	__property TNotifyEvent OnTimer  = { read=FOnTimer, write=FOnTimer } ;
} ;
//---------------------------------------------------------------------------
#endif
