//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "DigitDetector"
#pragma resource "*.dfm"
TBatchDetectForm *BatchDetectForm ;   
//---------------------------------------------------------------------------
__fastcall TBatchDetectForm::TBatchDetectForm(TComponent* Owner)
	: TForm(Owner)
{
	mLevelZoom = 1.0 ;
	mTimeZoom = 8.0 ;
	ConfigScrollBar();
	ComboBox1->ItemIndex = DigitDetector1->Priority ;
	mBuffer = new char[160000] ;

	mSampleBuffer = new char[12800000] ;
	mSampleDeltaBuffer = new unsigned short int[12800000/2] ;
	mSampleLevelBuffer = new float[12800000/2] ;

	mPulseList = new TPulse*[100] ;
	mPulseCount = 0 ;
	for(int index = 0 ; index < 100 ; index++)
	{
		mPulseList[index] = new TPulse ;
	}
	mGraph = new float[1100] ;

	mFFTBuffer = new complex<double>[513] ;

	mPulseCoefficient = 2.0 ;

	mScrolled = false ;
	mWindowStartPoint = 0 ;
	mWindowEndPoint = 3000 ;
	mCursorPoint = 0 ;
	mSelectionStartPoint = -1 ;
	mSelectionEndPoint = -1 ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::Button16Click(TObject *Sender)
{
	short int *signal ;

	signal = (short int *)mSampleBuffer ;

	if( !mScrolled )
		mStartPoint = mEndPoint ;
	else
		mStartPoint = ScrollBar1->Position ;

	mEndPoint = mSampleLength/2;
	char digit ;

	int avg_pulse_width, avg_dist ;

	if( mStartPoint < mEndPoint  &&  DigitDetector1->DetectPulseDigit( mStartPoint, mEndPoint, digit, true, avg_pulse_width, avg_dist, mPulseCount, signal, mSampleDeltaBuffer, mSampleLevelBuffer, mPulseList, mGraph ) )
	{
		ScrollBar1->Position = mStartPoint ;
		PaintBox1->Repaint();
		mScrolled = false ;
		Label3->Caption = digit ;
		Label4->Caption = mStartPoint / 8 ;
		Label5->Caption = "Pulse" ;
	}
}
//---------------------------------------------------------------------------

__fastcall TBatchDetectForm::~TBatchDetectForm()
{
	DigitDetector1->EndDetect() ;
	delete[] mGraph ;
	for(int index = 0 ; index < 100 ; index++)
	{
		delete mPulseList[index] ;
	}
	delete [] mPulseList ;

	delete [] mFFTBuffer ;

	delete [] mBuffer ;
	delete [] mSampleBuffer ;
	delete [] mSampleDeltaBuffer ;
	delete [] mSampleLevelBuffer ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::EDCoefChange(TObject *Sender)
{
	mPulseCoefficient = EDCoef->Text.ToDouble() ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::ScrollBar1Change(TObject *Sender)
{
	PaintBox1->Repaint() ;
	mScrolled = true ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::Button23Click(TObject *Sender)
{
	short int *signal ;

	signal = (short int *)mSampleBuffer ;

	int start_point=0, end_point = mSampleLength/2 ;
	char digit ;

	Label13->Caption = "" ;
	Update();

	while(start_point < end_point && DigitDetector1->DetectTone( start_point, end_point, digit, signal, mFFTBuffer ))
	{
		ScrollBar1->Position = start_point ;
		PaintBox1->Repaint();
		Label13->Caption = Label13->Caption + AnsiString(digit) ;
		Update();

		start_point = end_point ;
		end_point = mSampleLength/2 ;
	}

}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::PaintBox1MouseUp(TObject *Sender,
		TMouseButton Button, TShiftState Shift, int X, int Y)
{
	static int aux ;

	if( ScrollBar1->Enabled )
		ActiveControl = ScrollBar1 ;

	if( Shift.Contains(ssCtrl)  &&  mSelectionStartPoint!= -1 )
	{
		mSelectionEndPoint = mWindowStartPoint + ( X * mTimeZoom ) ;
		if( mSelectionEndPoint == mSelectionStartPoint )
		{
			mSelectionEndPoint = -1 ;
			mSelectionStartPoint = -1 ;
		}
		else
		{
			if( mSelectionEndPoint < mSelectionStartPoint )
			{
				aux = mSelectionEndPoint ;
				mSelectionEndPoint = mSelectionStartPoint ;
				mSelectionStartPoint = aux ;
			}
			mScrolled = true ;
		}
	}
	else
		mCursorPoint = mWindowStartPoint + ( X * mTimeZoom ) ;

	PaintBox1->Repaint() ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::PaintBox1Paint(TObject *Sender)
{
	static int x, length, sel_start, sel_end;
	static double coefficient ;


	StatusBar1->Panels->Items[1]->Text =  "Sample = " + IntToStr( int( mCursorPoint ) ) ;
	StatusBar1->Panels->Items[2]->Text =  "Amplitude = " + IntToStr( ((short int *)mSampleBuffer)[mCursorPoint] ) ;
	Label8->Caption = mWindowStartPoint / 8 ;

	if( mSelectionStartPoint > 0 )
		StatusBar1->Panels->Items[0]->Text = "Selection = " + IntToStr( mSelectionEndPoint - mSelectionStartPoint ) ;
	else
		StatusBar1->Panels->Items[0]->Text = "" ;


	if( CBNormalized->Checked )
	{
		StatusBar1->Panels->Items[4]->Text = "Level = " + FloatToStr( mSampleLevelBuffer[mCursorPoint] * mPulseCoefficient ) ;
		StatusBar1->Panels->Items[3]->Text = "Delta = " + IntToStr( int(mSampleDeltaBuffer[mCursorPoint] * mPulseCoefficient) ) ;
	}
	else
	{
		StatusBar1->Panels->Items[4]->Text = "Level = " + FloatToStr( mSampleLevelBuffer[mCursorPoint] ) ;
		StatusBar1->Panels->Items[3]->Text = "Delta = " + IntToStr( mSampleDeltaBuffer[mCursorPoint] ) ;
	}


	mWindowStartPoint = ScrollBar1->Position ;
	mWindowEndPoint = ScrollBar1->Position + 640 * mTimeZoom ;
	if( mWindowEndPoint > mSampleLength/2 )
		mWindowEndPoint = mSampleLength/2 ;

	length = mWindowEndPoint - mWindowStartPoint ;


	if( mSelectionEndPoint != -1  &&  mSelectionStartPoint != -1 )
	{
		sel_start = ( mSelectionStartPoint - mWindowStartPoint ) / mTimeZoom ;
		if( sel_start < 0 )
			sel_start = 0 ;
		if( sel_start > 640  )
			sel_start = -1 ;

		sel_end = ( mSelectionEndPoint - mWindowStartPoint ) / mTimeZoom ;
		if( sel_end < 0 )
			sel_end = -1 ;
		if( sel_end > 640  )
			sel_end = 640 ;
		if( sel_end != -1  &&  sel_start != -1 )
		{
			PaintBox1->Canvas->Pen->Color = (TColor)0x009FA7B5 ;
			PaintBox1->Canvas->Brush->Color = (TColor)0x009FA7B5 ;
			PaintBox1->Canvas->Rectangle( sel_start, 0 , sel_end , 320 ) ;
		}
	}



	short int * signal =  (short int *)(&mSampleBuffer[mWindowStartPoint*2]);

	if( CBNormalized->Checked )
		coefficient = mPulseCoefficient ;
	else
		coefficient = 1.0 ;

	PaintBox1->Canvas->Brush->Style = bsSolid ;

	if(CBSignal->Checked)
	{
		PaintBox1->Canvas->Pen->Color = clBlack;
		PaintBox1->Canvas->MoveTo(0, 160) ;

		for( x = 0 ; x < length ; x++ )
		{
			PaintBox1->Canvas->LineTo( x / mTimeZoom , 160.0 - 0.0047 * signal[x] * coefficient * mLevelZoom) ;
		}
	}

	PaintBox1->Canvas->Pen->Color = clSilver ;
	PaintBox1->Canvas->MoveTo(0, 160 - 0.0047 * 0) ;
	PaintBox1->Canvas->LineTo(640, 160 - 0.0047 * 0) ;

	if(CBSignalDiff->Checked)
	{
		PaintBox1->Canvas->Pen->Color = clBlue ;
		PaintBox1->Canvas->MoveTo( 0, 320.0 - 0.0047 * mSampleDeltaBuffer[mWindowStartPoint] * coefficient * mLevelZoom ) ;

		for( x = 0 ; x < length ; x++)
		{
			PaintBox1->Canvas->LineTo( x / mTimeZoom, 320.0 - 0.0047 * mSampleDeltaBuffer[x + mWindowStartPoint] * coefficient * mLevelZoom) ;
		}
	}

	if(CBSignalLevel->Checked)
	{
		PaintBox1->Canvas->Pen->Color = clWhite ;
		PaintBox1->Canvas->MoveTo( 0, 160.0 - 4.7 * ( -5.0 + mSampleLevelBuffer[mWindowStartPoint] * coefficient ) * mLevelZoom ) ;

		for( x = 0 ; x < length ; x++)
		{
			PaintBox1->Canvas->LineTo( x / mTimeZoom, 160.0 - 4.7 * ( -5.0 + mSampleLevelBuffer[x + mWindowStartPoint] * coefficient ) * mLevelZoom ) ;
		}
	}

	if( mCursorPoint - mWindowStartPoint > 1  &&  mCursorPoint - mWindowStartPoint < 640 * mTimeZoom )
	{
		PaintBox1->Canvas->Pen->Color = clAqua ;
		PaintBox1->Canvas->Pen->Style = psDot ;
		PaintBox1->Canvas->MoveTo( ( mCursorPoint - mWindowStartPoint ) / mTimeZoom , 10 ) ;
		PaintBox1->Canvas->LineTo( ( mCursorPoint - mWindowStartPoint ) / mTimeZoom  , 310 ) ;
		PaintBox1->Canvas->Pen->Style = psSolid ;
	}

	if( mNextActivityPoint - mWindowStartPoint > 1  &&  mNextActivityPoint - mWindowStartPoint < 640 * mTimeZoom )
	{
		PaintBox1->Canvas->Pen->Color = clFuchsia ;
		PaintBox1->Canvas->Pen->Style = psDash ;
		PaintBox1->Canvas->MoveTo( ( mNextActivityPoint - mWindowStartPoint ) / mTimeZoom , 10 ) ;
		PaintBox1->Canvas->LineTo( ( mNextActivityPoint - mWindowStartPoint ) / mTimeZoom  , 310 ) ;
		PaintBox1->Canvas->Pen->Style = psSolid ;
	}

	if( mEndPoint - mWindowStartPoint > 1  &&  mEndPoint - mWindowStartPoint < 640 * mTimeZoom )
	{
		PaintBox1->Canvas->Pen->Color = clYellow ;
		PaintBox1->Canvas->Brush->Color = clYellow ;
		PaintBox1->Canvas->Rectangle( ( mEndPoint - mWindowStartPoint ) / mTimeZoom - 1, 100 , ( mEndPoint - mWindowStartPoint ) / mTimeZoom + 1 , 220 ) ;
	}

	if( mStartPoint - mWindowStartPoint > 1  &&  mStartPoint - mWindowStartPoint < 640 * mTimeZoom )
	{
		PaintBox1->Canvas->Pen->Color = clYellow ;
		PaintBox1->Canvas->Brush->Color = clYellow ;
		PaintBox1->Canvas->Rectangle( (mStartPoint - mWindowStartPoint ) / mTimeZoom - 1, 100 , ( mStartPoint - mWindowStartPoint ) / mTimeZoom + 1 , 220 ) ;
	}

	for ( x = 0 ; x < mPulseCount ; x++ )
	{
		if(!mPulseList[x]->IsNoise)
		{
			PaintBox1->Canvas->Pen->Color = clLime ;
			PaintBox1->Canvas->Brush->Color = clLime ;
		}
		else
		{
			PaintBox1->Canvas->Pen->Color = clRed ;
			PaintBox1->Canvas->Brush->Color = clRed ;
		}

		if(mPulseList[x]->IsLeading)
			PaintBox1->Canvas->Rectangle( ( mPulseList[x]->PulsePoint - mWindowStartPoint) / mTimeZoom - 1 - mPulseList[x]->Magnitude , 159 - mPulseList[x]->Magnitude , ( mPulseList[x]->PulsePoint - mWindowStartPoint ) / mTimeZoom + 1 + mPulseList[x]->Magnitude , 161 + mPulseList[x]->Magnitude ) ;
		else
			PaintBox1->Canvas->Ellipse( ( mPulseList[x]->PulsePoint - mWindowStartPoint ) / mTimeZoom - 1 - mPulseList[x]->Magnitude , 159 - mPulseList[x]->Magnitude , ( mPulseList[x]->PulsePoint - mWindowStartPoint ) / mTimeZoom + 1 + mPulseList[x]->Magnitude , 161 + mPulseList[x]->Magnitude ) ;

		PaintBox1->Canvas->Rectangle( ( mPulseList[x]->StartPoint - mWindowStartPoint ) / mTimeZoom , 3 + (x%2)*3, ( mPulseList[x]->EndPoint - mWindowStartPoint ) / mTimeZoom , 5 + (x%2)*3) ;

		PaintBox1->Canvas->Rectangle( ( mPulseList[x]->EchoPoint - mWindowStartPoint ) / mTimeZoom - 1  , 140 , ( mPulseList[x]->EchoPoint - mWindowStartPoint ) / mTimeZoom , 180  ) ;

		PaintBox1->Canvas->Pen->Color = clOlive ;
		PaintBox1->Canvas->Brush->Color = clOlive ;
		PaintBox1->Canvas->Rectangle( ( mPulseList[x]->AttackPoint - mWindowStartPoint ) / mTimeZoom - 1  , 140 , ( mPulseList[x]->AttackPoint - mWindowStartPoint ) / mTimeZoom , 180  ) ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::Button24Click(TObject *Sender)
{
	short int *signal ;

	signal = (short int *)mSampleBuffer ;

	int end_point = mSampleLength/2, start_point = 0;
	char digit ;
	int avg_pulse_width, avg_dist ;

	Label13->Caption = "" ;
	Update();
	while( start_point + 1000 < end_point  &&  DigitDetector1->DetectPulseDigit( start_point, end_point, digit, true, avg_pulse_width, avg_dist, mPulseCount, signal, mSampleDeltaBuffer, mSampleLevelBuffer, mPulseList, mGraph ) )
	{
		ScrollBar1->Position = start_point ;
		Label13->Caption = Label13->Caption + AnsiString(digit) ;
		Update();
		start_point = end_point ;
		end_point = mSampleLength/2;
	}
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::Button25Click(TObject *Sender)
{
	Memo1->Clear();
	mCursorPoint = 0 ;
	ScrollBar1->Position = 0 ;
	PaintBox1->Repaint() ;

	if (OpenDialog1->Execute())
	{
		BTStop->Enabled = true ;
		BTOpen->Enabled = false ;
		GroupBox1->Enabled = false ;

		mFileIndex = 0 ;

		mFullPathFilename = OpenDialog1->Files->Strings[mFileIndex];
		ExtractFileName();
		Label1->Caption = mFileNumber ;
		mRegions = "" ;

		mCurrentFile = fopen( mFullPathFilename.c_str() , "rb") ;
		if( mCurrentFile == NULL )
		{
			ShowMessage("Can not open file :  " + mFullPathFilename );
		}
		else
		{
			fseek(mCurrentFile, 0, SEEK_SET) ;
			mSampleLength = fread(mSampleBuffer, 1, 12800000, mCurrentFile) ;
			fclose(mCurrentFile);

			Label13->Caption = "" ;
			ScrollBar1->Max = mSampleLength/2 ;
			ConfigScrollBar();
			DigitDetector1->BeginDetect( 0, 0, false, true, true ) ;
			if( DigitDetector1->Blocking )
			{
				while( DigitDetector1->ContinueDetect() )
				{
					if( CBConfirm->Checked )
					{
						if( IDNO == Application->MessageBox( "Continue Detecting?", "Blocking Process Confirmation" , MB_YESNO ) )
						{
							DigitDetector1->EndDetect() ;
						}
					}
				}
			}
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::SpeedButton9Click(TObject *Sender)
{
	mLevelZoom = mLevelZoom * 2.0 ;
	PaintBox1->Repaint() ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::SpeedButton10Click(TObject *Sender)
{
	mLevelZoom = mLevelZoom / 2.0 ;
	PaintBox1->Repaint() ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::SpeedButton12Click(TObject *Sender)
{
	mTimeZoom = mTimeZoom * 2.0 ;
	ConfigScrollBar();
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::SpeedButton11Click(TObject *Sender)
{
	mTimeZoom = mTimeZoom / 2.0 ;
	ConfigScrollBar();
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::Button26Click(TObject *Sender)
{
	float coefficient ;
	if( CBNormalized->Checked )
		coefficient = mPulseCoefficient ;
	else
		coefficient = 1 ;


	if( mSelectionEndPoint != -1 )
	{
		if( !mScrolled  &&  mEndPoint != -1 )
			mStartPoint = mEndPoint ;
		else
			mStartPoint = mSelectionStartPoint ;

		mEndPoint = mSelectionEndPoint ;
	}
	else
	{
		if( !mScrolled )
			mStartPoint = mEndPoint ;
		else
			mStartPoint = ScrollBar1->Position ;

		mEndPoint = mSampleLength/2;
	}


	if( mStartPoint < mEndPoint  &&  DigitDetector1->FindSoundSignal( mStartPoint, mEndPoint, mCursorPoint, mNextActivityPoint, mSampleLevelBuffer, mSampleDeltaBuffer, coefficient, 3.0, 7.0, 0.5, 0.25, true, 500.0, 0.1, 0.1, 40, 10000 ) )
	{
		if( mStartPoint < ScrollBar1->Position + 10  ||  mEndPoint > ScrollBar1->Position + 640 * mTimeZoom - 10 )
		{
			if( ScrollBar1->Position < mStartPoint - 900 * mTimeZoom )
				ScrollBar1->Position = mStartPoint - 5 * mTimeZoom ;
			else
				ScrollBar1->Position = mStartPoint - 260 * mTimeZoom ;
		}

		PaintBox1->Repaint();
		mScrolled = false ;
	}
	else
		mScrolled = true ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::Button27Click(TObject *Sender)
{
	float coefficient ;
	if( CBNormalized->Checked )
		coefficient = mAmbienceCoefficient ;
	else
		coefficient = 1 ;

	if( mSelectionEndPoint != -1 )
	{
		if( !mScrolled  &&  mEndPoint != -1 )
			mStartPoint = mEndPoint ;
		else
			mStartPoint = mSelectionStartPoint ;

		mEndPoint = mSelectionEndPoint ;
	}
	else
	{
		if( !mScrolled )
			mStartPoint = mEndPoint ;
		else
			mStartPoint = ScrollBar1->Position ;

		mEndPoint = mSampleLength/2;
	}

	if( mStartPoint < mEndPoint  &&  DigitDetector1->FindSoundSignal( mStartPoint, mEndPoint, mCursorPoint, mNextActivityPoint, mSampleLevelBuffer, mSampleDeltaBuffer, coefficient, 1.0, 100.0, 0.1, 0.05, true, 500.0, 0.1, 0.05, 20, 2000 ) )
	{
		if( mStartPoint < ScrollBar1->Position + 10  ||  mEndPoint > ScrollBar1->Position + 640 * mTimeZoom - 10 )
		{
			if( ScrollBar1->Position < mStartPoint - 900 * mTimeZoom )
				ScrollBar1->Position = mStartPoint - 5 * mTimeZoom ;
			else
				ScrollBar1->Position = mStartPoint - 260 * mTimeZoom ;
		}
		PaintBox1->Repaint();
		mScrolled = false ;
	}
	else
		mScrolled = true ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::PaintBox1MouseDown(TObject *Sender,
		TMouseButton Button, TShiftState Shift, int X, int Y)
{
	PaintBox1->Canvas->MoveTo( X , 10 ) ;
	PaintBox1->Canvas->LineTo( X  , 310 ) ;

	mCursorPoint = mWindowStartPoint + ( X * mTimeZoom ) ;

	if( Shift.Contains(ssCtrl) )
	{
		mSelectionStartPoint = mWindowStartPoint + ( X * mTimeZoom ) ;
		mSelectionEndPoint = -1 ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::Button28Click(TObject *Sender)
{
	float coefficient ;
	if( CBNormalized->Checked )
		coefficient = mPulseCoefficient ;
	else
		coefficient = 1 ;


	if( mSelectionEndPoint != -1 )
	{
		if( !mScrolled  &&  mEndPoint != -1 )
			mStartPoint = mEndPoint ;
		else
			mStartPoint = mSelectionStartPoint ;

		mEndPoint = mSelectionEndPoint ;
	}
	else
	{
		if( !mScrolled )
			mStartPoint = mEndPoint ;
		else
			mStartPoint = ScrollBar1->Position ;

		mEndPoint = mSampleLength/2;
	}

	if( mStartPoint < mEndPoint  &&  DigitDetector1->FindSoundSignal( mStartPoint, mEndPoint, mCursorPoint, mNextActivityPoint, mSampleLevelBuffer, mSampleDeltaBuffer, coefficient, 3.0, 5.0, 0.5, 0.25, false, 500.0, 0.02, 0.02, 40, 10000 ) )
	{
		if( mStartPoint < ScrollBar1->Position + 10  ||  mEndPoint > ScrollBar1->Position + 640 * mTimeZoom - 10 )
		{
			if( ScrollBar1->Position < mStartPoint - 900 * mTimeZoom )
				ScrollBar1->Position = mStartPoint - 5 * mTimeZoom ;
			else
				ScrollBar1->Position = mStartPoint - 260 * mTimeZoom ;
		}

		PaintBox1->Repaint();
		mScrolled = false ;
	}
	else
		mScrolled = true ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::Button29Click(TObject *Sender)
{
	float coefficient ;
	if( CBNormalized->Checked )
		coefficient = mPulseCoefficient ;
	else
		coefficient = 1 ;


	if( mSelectionEndPoint != -1 )
	{
		if( !mScrolled  &&  mEndPoint != -1 )
			mStartPoint = mEndPoint ;
		else
			mStartPoint = mSelectionStartPoint ;

		mEndPoint = mSelectionEndPoint ;
	}
	else
	{
		if( !mScrolled )
			mStartPoint = mEndPoint ;
		else
			mStartPoint = ScrollBar1->Position ;

		mEndPoint = mSampleLength/2;
	}

	if( mStartPoint < mEndPoint  &&  DigitDetector1->FindSoundSignal( mStartPoint, mEndPoint, mCursorPoint, mNextActivityPoint, mSampleLevelBuffer, mSampleDeltaBuffer, coefficient, 3.0, 27.0, 0.5, 0.25, true, 500.0, 0.05, 0.02, 40, 10000 ) )
	{
		if( mStartPoint < ScrollBar1->Position + 10  ||  mEndPoint > ScrollBar1->Position + 640 * mTimeZoom - 10 )
		{
			if( ScrollBar1->Position < mStartPoint - 900 * mTimeZoom )
				ScrollBar1->Position = mStartPoint - 5 * mTimeZoom ;
			else
				ScrollBar1->Position = mStartPoint - 260 * mTimeZoom ;
		}

		PaintBox1->Repaint();
		mScrolled = false ;
	}
	else
		mScrolled = true ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::DigitDetector1DoSupplyBuffer(TComponent *Sender,
		short *&Buffer, int &Length, bool &aIsLastBuffer, int Position)
{
	Buffer = (short int *)( mSampleBuffer + Position * 2 ) ;
	Length = 85000 + random(5000) ;
	mRegions = mRegions + AnsiString( Position ) + " , " + AnsiString( Length ) + " ;   " ;

	aIsLastBuffer = false ;
	if( Length + Position > mSampleLength / 2 )
	{
		Length = mSampleLength / 2 - Position;
		aIsLastBuffer = true ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::DigitDetector1DigitDetected(TComponent *Sender,
		char Digit, unsigned TimeTicks, bool IsDTMF)
{
	if( Digit != '.'  &&  Digit != '!' )
		Label13->Caption = Label13->Caption + Digit ;

	ScrollBar1->Position = TimeTicks * 8 ;
	Label3->Caption = Digit ;
	Label4->Caption = TimeTicks ;
	Label5->Caption = ( IsDTMF ? "Tone" : "Pulse" ) ;
	PaintBox1->Repaint();
	if( CBConfirm->Checked )
	{
		if( IDNO == Application->MessageBox( ("Digit found = " + AnsiString(Digit) + " , Continue Detecting?").c_str(), "Confirm" , MB_YESNO ) )
			DigitDetector1->EndDetect() ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::DigitDetector1DetectionEnd(TObject *Sender)
{
	if( Label13->Caption == mFileNumber )
	{
		Memo1->Lines->Append( mFileName ) ;
	}
	else
	{
		MessageBeep(-1) ;
		Memo1->Lines->Append("_______________");
		Memo1->Lines->Append( mFullPathFilename ) ;
		Memo1->Lines->Append( mFileName ) ;
		Memo1->Lines->Append(" ?? " + Label13->Caption );
		Memo1->Lines->Append(" Length " + mRegions );
		Memo1->Lines->Append("***************");
	}

	Label3->Caption = "" ;
	Label4->Caption = "" ;
	Label5->Caption = "" ;
	ScrollBar1->Position = 0 ;

	mFileIndex ++;
	if( mFileIndex < OpenDialog1->Files->Count)
	{
		mFullPathFilename = OpenDialog1->Files->Strings[mFileIndex];
		ExtractFileName();
		Label1->Caption = mFileNumber ;

		mRegions = "" ;

		mCurrentFile = fopen( mFullPathFilename.c_str() , "rb") ;
		if( mCurrentFile == NULL )
		{
			ShowMessage("Can not open file :  " + mFullPathFilename );
		}
		else
		{
			fseek(mCurrentFile, 0, SEEK_SET) ;
			mSampleLength = fread(mSampleBuffer, 1, 12800000, mCurrentFile) ;
			fclose(mCurrentFile);

			Label13->Caption = "" ;
			ScrollBar1->Max = mSampleLength/2 ;
			ConfigScrollBar();
			DigitDetector1->BeginDetect( 0, 0, false, true, true ) ;
		}
	}
	else
	{
		BTStop->Enabled = false ;
		Memo1->Lines->Append("-------------------");
		DigitDetector1->ResetSampleParams();
		DigitDetector1->GetSampleParams( mSampleDeltaBuffer, mSampleLevelBuffer, (short int *)mSampleBuffer, mSampleLength/2 ) ;
		Memo1->Lines->Append("        End        ");
		BTOpen->Enabled = true ;
		GroupBox1->Enabled = true ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::Button30Click(TObject *Sender)
{
	OpenDialog1->Files->Clear() ;
	DigitDetector1->EndDetect() ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::CheckBoxClick(TObject *Sender)
{
	PaintBox1->Repaint() ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::CheckBox1Click(TObject *Sender)
{
	DigitDetector1->Blocking = CheckBox1->Checked ;
	CheckBox1->Checked = DigitDetector1->Blocking ;
	ComboBox1->Enabled = ! DigitDetector1->Blocking ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::ComboBox1Change(TObject *Sender)
{
	DigitDetector1->Priority = ComboBox1->ItemIndex ;
	ComboBox1->ItemIndex = DigitDetector1->Priority ;
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::ExtractFileName()
{
	int char_index, path_pos, extension_pos, string_length;
	int number_pos, number_length ;

	string_length = mFullPathFilename.Length();
	extension_pos = string_length + 1;
	path_pos = 1;
	number_pos = 0 ;
	number_length = 0 ;

	for( char_index = string_length; char_index > 0  &&  path_pos == 1; char_index-- )
	{
		if( mFullPathFilename[char_index] == '\\'  &&  path_pos == 1 )
			path_pos = char_index;

		if( mFullPathFilename[char_index] == '.'  &&  extension_pos == string_length + 1)
			extension_pos = char_index;

		if( mFullPathFilename[char_index] == '_'  &&  path_pos == 1 )
		{
			if( number_pos == 0 )
				number_pos = char_index;
			else
			{
				number_length = number_pos - char_index - 1 ;
				number_pos = char_index + 1 ;
			}
		}
	}

	mFileName = mFullPathFilename.SubString( path_pos + 1, extension_pos - path_pos -1 );
	mFileNumber = mFullPathFilename.SubString( number_pos, number_length );
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::ConfigScrollBar()
{
	if( mTimeZoom * 640 < ScrollBar1->Max )
	{
		ScrollBar1->Enabled = true ;
		ScrollBar1->LargeChange = 80 * mTimeZoom ;

		if( mTimeZoom * 640 < GetSystemMetrics(SM_CYVTHUMB) )
			ScrollBar1->PageSize = GetSystemMetrics(SM_CYVTHUMB) ;
		else
			ScrollBar1->PageSize = mTimeZoom * 640 ;

		if( mCursorPoint > mWindowStartPoint  &&  mCursorPoint < mWindowEndPoint )
			ScrollBar1->Position = mCursorPoint + ( ScrollBar1->Position - mCursorPoint ) / 2 ;
		else
			ScrollBar1->Position = mCursorPoint - 80 ;

		PaintBox1->Repaint() ;
		ActiveControl = NULL ;
		ActiveControl = ScrollBar1 ;
	}
	else
	{
		ScrollBar1->Position = 0 ;
		ScrollBar1->Enabled = false ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TBatchDetectForm::Help1Click(TObject *Sender)
{
	Application->HelpCommand(HELP_CONTENTS, 0) ;
}
//---------------------------------------------------------------------------

