//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SortedStringGrid"
#pragma resource "*.dfm"
TSortedGridForm *SortedGridForm ;
//---------------------------------------------------------------------------
__fastcall TSortedGridForm::TSortedGridForm(TComponent* Owner)
	: TForm(Owner)
{
	AnsiString country[17][5] =
	{
			{ "Country", "Captial", "Time Zone", "Area", "Population" }
		, { "Argentina", "Buenos Aires", "GMT-03:00", "2777815.00", "32300003.00" }
		, { "Bolivia", "La Paz", "GMT-04:00", "1098575.00", "7300000.00" }
		, { "Brazil", "Brasilia", "GMT-03:00", "8511196.00", "150400000.00" }
		, { "Chile", "Santiago", "GMT-04:00", "756943.00", "13200000.00" }
		, { "Colombia", "Bogota", "GMT-05:00", "1138907.00", "33000000.00" }
		, { "Cuba", "Havana", "GMT-05:00", "114524.00", "10600000.00" }
		, { "Ecuador", "Quito", "GMT-05:00", "455502.00", "10600000.00" }
		, { "El Salvador", "San Salvador", "GMT-06:00", "20865.00", "5300000.00" }
		, { "Guyana", "Georgetown", "GMT-03:00", "214969.00", "800000.00" }
		, { "Jamaica", "Kingston", "GMT-05:00", "11424.00", "2500000.00" }
		, { "Mexico", "Mexico City", "GMT-06:00", "1967180.00", "88600000.00" }
		, { "Nicaragua", "Managua", "GMT-06:00", "139000.00", "3900000.00" }
		, { "Paraguay", "Asuncion", "GMT-03:00", "406576.00", "4660000.00" }
		, { "Peru", "Lima", "GMT-05:00", "1285215.00", "21600000.00" }
		, { "Uruguay", "Montevideo", "GMT-03:00", "176140.00", "3002000.00" }
		, { "Venezuela", "Caracas", "GMT-04:00", "912047.00", "19700000.00" }
	};

	for( int row_index = 0 ; row_index < 17 ; row_index++ )
	{
		for ( int column_index = 0 ; column_index < 5 ; column_index++ )
		{
			SortedStringGrid1->Cells[column_index + 1][row_index] = country[row_index][column_index] ;
		}

		if( row_index > 0 )
			SortedStringGrid1->Cells[0][row_index] = row_index ;
	}

	SortedStringGrid1->ColWidths[0] = 20 ;
	SortedStringGrid1->ColumnId[0] = 1 ; // Number type
	SortedStringGrid1->ColumnId[3] = 0 ; // String type
	SortedStringGrid1->ColumnId[3] = 0 ; // String type
	SortedStringGrid1->ColumnId[3] = 2 ; // TimeZone type
	SortedStringGrid1->ColumnId[4] = 1 ; // Number
	SortedStringGrid1->ColumnId[5] = 1 ; // Number

}
//---------------------------------------------------------------------------

void __fastcall TSortedGridForm::SortedStringGrid1CustomCompare(
			TComponent *Sender, AnsiString String1, int ColumnIndex1,
			int RowIndex1, AnsiString String2, int ColumnIndex2, int RowIndex2,
			int &Result)
{
	if( SortedStringGrid1->ColumnId[ColumnIndex1] == 1  &&  SortedStringGrid1->ColumnId[ColumnIndex2] == 1 )
	{
		if( String1.ToDouble() > String2.ToDouble() )
			Result = 1 ;

		if( String1.ToDouble() < String2.ToDouble() )
			Result = -1 ;
	}
	else
	{
		Result = CompareText( String1, String2 ) ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TSortedGridForm::SortedStringGrid1SelectColumn(
			TComponent *Sender, int Index, bool &CanProceed)
{
	if( SortedStringGrid1->ColumnId[Index] != RadioGroup1->ItemIndex )
		CanProceed = false ;
}
//---------------------------------------------------------------------------

void __fastcall TSortedGridForm::SortedStringGrid1MouseDown(
			TObject *Sender, TMouseButton Button, TShiftState Shift, int X,
			int Y)
{
	int column_index, row_index, index ;

	SortedStringGrid1->MouseToCell(X, Y, column_index, row_index) ;

	if( column_index == 0  &&  row_index == 0 )
	{
		for( index = 0 ; index < SortedStringGrid1->ColCount ; index++ )
		{
			SortedStringGrid1->SetColumnAttributes( index, false, false, false ) ;
		}

		for( index = 0 ; index < SortedStringGrid1->RowCount ; index++ )
		{
			SortedStringGrid1->SetRowAttributes( index, false, false, false ) ;
		}

		SortedStringGrid1->Repaint() ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TSortedGridForm::SortedStringGrid1SortRows(
			TComponent *Sender, int Index, TGridSortEventType EventType,
			bool &CanProceed)
{
	if( ! CheckBox1->Checked  &&  EventType != gsRemove )
		CanProceed = false ;
}
//---------------------------------------------------------------------------

void __fastcall TSortedGridForm::Button1Click(TObject *Sender)
{
	if( ColorDialog1->Execute() )
		SortedStringGrid1->SortedColor = ColorDialog1->Color ;
}
//---------------------------------------------------------------------------

void __fastcall TSortedGridForm::Button2Click(TObject *Sender)
{
	if( FontDialog1->Execute() )
		SortedStringGrid1->Font = FontDialog1->Font ;
}
//---------------------------------------------------------------------------

void __fastcall TSortedGridForm::Button4Click(TObject *Sender)
{
	if( ColorDialog1->Execute() )
		SortedStringGrid1->Color = ColorDialog1->Color ;
}
//---------------------------------------------------------------------------

void __fastcall TSortedGridForm::Button3Click(TObject *Sender)
{
	if( FontDialog1->Execute() )
		SortedStringGrid1->FixedFont = FontDialog1->Font ;
}
//---------------------------------------------------------------------------

void __fastcall TSortedGridForm::H1Click(TObject *Sender)
{
	Application->HelpCommand(HELP_CONTENTS, 0);
}
//---------------------------------------------------------------------------

