//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "MultimediaTimer"
#pragma link "WaveDevice"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	int i = 0 ;
	WaveDevice1->WaveInDeviceID = i ;
	while( WaveDevice1->WaveInDeviceID == i )
	{
		ComboBox1->Items->Append( WaveDevice1->WaveInDeviceName ) ;
		WaveDevice1->WaveInDeviceID = ++i ;
	}
	WaveDevice1->WaveInDeviceID = 0 ;
	ComboBox1->ItemIndex = 0 ;


	i = 0 ;
	WaveDevice1->WaveOutDeviceID = i ;
	while( WaveDevice1->WaveOutDeviceID == i )
	{
		ComboBox2->Items->Append( WaveDevice1->WaveOutDeviceName ) ;
		WaveDevice1->WaveOutDeviceID = ++i ;
	}
	WaveDevice1->WaveOutDeviceID = 0 ;
	ComboBox2->ItemIndex = 0 ;

	ComboBox4->ItemIndex = 1 ;
	WaveDevice1->WaveInChannels = 2 ;
	WaveDevice1->WaveOutChannels = 2 ;
	WaveDevice1->WaveInSamplesPerSec = ComboBox3->Text.ToInt() ;
	WaveDevice1->WaveOutSamplesPerSec = ComboBox3->Text.ToInt() ;

	mIsRecording = false ;
	mIsPlaying = false ;
	NewClick( this );
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	SBStopClick( this ) ;
	free( mPlaybackBuffer ) ;
	CanClose = true ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SettingsChange(TObject *Sender)
{
	WaveDevice1->WaveInDeviceID = ComboBox1->ItemIndex ;
	WaveDevice1->WaveOutDeviceID = ComboBox2->ItemIndex ;
	
	WaveDevice1->WaveInChannels = 1 + ComboBox4->ItemIndex ;
	WaveDevice1->WaveInSamplesPerSec = ComboBox3->Text.ToInt() ;

	WaveDevice1->WaveOutChannels = 1 + ComboBox4->ItemIndex ;
	WaveDevice1->WaveOutSamplesPerSec = ComboBox3->Text.ToInt() ;

	mWindow = 4000 * WaveDevice1->WaveInChannels ;

	if( WaveDevice1->WaveInChannels == 1 )
	{
		this->ClientHeight = 285 ;
		PaintBox2->Visible = false ;
		Bevel2->Visible = false ;
		Label4->Visible = false ;
		PaintBox1->Repaint() ;
	}
	else
	{
		this->ClientHeight = 380 ;
		PaintBox2->Visible = true ;
		Bevel2->Visible = true ;
		Label4->Visible = true ;
		PaintBox1->Repaint() ;
		PaintBox2->Repaint() ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TBRecordChange(TObject *Sender)
{
	SBRewind->Enabled = ( TBRecord->Position != 0 ) ;
	SBForward->Enabled = ( TBRecord->Position != TBRecord->Max ) ;

	mPosition = TBRecord->Position  - ( TBRecord->Position % WaveDevice1->WaveInBlockAlign ) ;

	LBPosition->Caption = (10 * ( mPosition + mWindow ) / WaveDevice1->WaveOutAvgBytesPerSec)/10.0 ;
	LBLength->Caption = (10 * mPlaybackSize / WaveDevice1->WaveOutAvgBytesPerSec)/10.0 ;

	PaintBox1->Repaint() ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WaveDeviceError(TComponent *Sender,
			char *ErrorText, int ErrorCode)
{
	ShowMessage(ErrorText) ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SBRewindClick(TObject *Sender)
{
	TBRecord->Position = 0 ;

	if( mIsPlaying )
	{
		SBStopClick( this );
		TBRecord->Position = mSelStart ;
		SBPlayClick( this );
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SBPlayClick(TObject *Sender)
{
	WaveDevice1->WaveOutActive = true ;
	if( ! WaveDevice1->WaveOutActive )
	{
		ShowMessage("Playback device is not present or the format is not supported.") ;
		return ;
	}

	mSelStart = mPosition ;
	if( WaveDevice1->WaveOutPush( ( mPlaybackBuffer + mSelStart ), mPlaybackSize - mSelStart, 0 ) )
	{
		WaveDevice1->WaveOutStart() ;
		mIsPlaying = true ;
		MultimediaTimer1->Active = true ;

		SBPlay->Enabled = false ;
		SBRecord->Enabled = false ;
		SBStop->Enabled = true ;
		ComboBox1->Enabled = false ;
		ComboBox2->Enabled = false ;
		ComboBox3->Enabled = false ;
		ComboBox4->Enabled = false ;
		TBRecord->Enabled = false ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MultimediaTimer1Timer(TObject *Sender)
{
	static void *buffer ;
	static int buffer_length, bytes, position, tag ;

	if( mIsPlaying )
	{
		TBRecord->Position = mSelStart + WaveDevice1->WaveOutPosition ;
		if( WaveDevice1->WaveOutWaitForNotify(10) )
		{
			if( WaveDevice1->WaveOutPop( buffer, buffer_length, bytes, position, tag ) )
			{
				SBStopClick( this ) ;
				TBRecord->Position = mSelStart ;
			}
			return ;
		}
	}

	if( WaveDevice1->WaveInWaitForNotify(10) )
	{
		while( WaveDevice1->WaveInPop( buffer, buffer_length, bytes, position, tag ) )
		{
			if( mSelStart + position + bytes > mBufferSize )
			{
				int new_size = mBufferSize + 10 * WaveDevice1->WaveInAvgBytesPerSec ;
				void *playback_buffer = realloc( mPlaybackBuffer, new_size ) ;
				if( playback_buffer == NULL )
				{
					SBStopClick(this) ;
					delete buffer ;
					return ;
				}
				mPlaybackBuffer = (char *) playback_buffer ;
				mBufferSize = new_size ;
			}

			memcpy( mPlaybackBuffer + mSelStart + position, buffer, bytes ) ;
			if( mPlaybackSize < mSelStart + position )
			{
				mPlaybackSize = mSelStart + position ;
				TBRecord->Max = mPlaybackSize - mWindow ;
			}
			TBRecord->Position = mSelStart + position ;

			WaveDevice1->WaveInPush( buffer, mWindow, tag ) ;
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SBRecordClick(TObject *Sender)
{
	WaveDevice1->WaveInActive = true ;
	if( ! WaveDevice1->WaveInActive )
	{
		ShowMessage("Record device is not present or the format is not supported.") ;
		return ;
	}

	for( int tag = 0 ; tag < 20 ; tag++ )
	{
		char *buffer = new char[mWindow] ;

		if( ! WaveDevice1->WaveInPush( buffer, mWindow, tag ) )
		{
			delete [] buffer ;
		}
	}

	mSelStart = mPosition ;
	WaveDevice1->WaveInStart() ;
	mIsRecording = true ;
	MultimediaTimer1->Active = true ;

	SBRecord->Enabled = false ;
	SBPlay->Enabled = false ;
	SBStop->Enabled = true ;
	ComboBox1->Enabled = false ;
	ComboBox2->Enabled = false ;
	ComboBox3->Enabled = false ;
	ComboBox4->Enabled = false ;
	TBRecord->Enabled = false ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SBStopClick(TObject *Sender)
{
	static void *buffer ;
	static int buffer_length, bytes, position, tag ;

	MultimediaTimer1->Active = false ;

	if( mIsPlaying )
	{
		WaveDevice1->WaveOutStop() ;
		WaveDevice1->WaveOutReset() ;
		WaveDevice1->WaveOutPop( buffer, buffer_length, bytes, position, tag ) ;
		WaveDevice1->WaveOutActive = false ;
		mIsPlaying = false ;
	}

	if( mIsRecording )
	{
		WaveDevice1->WaveInStop() ;
		WaveDevice1->WaveInReset() ;
		while( WaveDevice1->WaveInPop( buffer, buffer_length, bytes, position, tag ) )
		{
			delete [] buffer ;
		}
		WaveDevice1->WaveInActive = false ;
		mIsRecording = false ;
		TBRecord->Position = mSelStart ;
	}

	ComboBox1->Enabled = true ;
	ComboBox2->Enabled = true ;
	ComboBox3->Enabled = true ;
	ComboBox4->Enabled = true ;
	SBStop->Enabled = false ;
	SBRecord->Enabled = true ;
	SBPlay->Enabled = true ;
	TBRecord->Enabled = true ;
	ActiveControl = TBRecord ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SBForwardClick(TObject *Sender)
{
	if( mIsPlaying )
	{
		SBStopClick( this ) ;
	}

	TBRecord->Position = TBRecord->Max ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::OpenClick(TObject *Sender)
{
	if( OpenDialog1->Execute() )
	{
		SBStopClick( this ) ;
		try
		{
			TFileStream *file = new TFileStream( OpenDialog1->FileName, fmOpenRead ) ;

			int new_playback_size = file->Size ;
			void *playback_buffer = realloc( mPlaybackBuffer, new_playback_size ) ;

			if( playback_buffer == NULL )
			{
				ShowMessage("memory allocation error!") ;
				return ;
			}
			mPlaybackBuffer = (char *) playback_buffer ;
			mPlaybackSize = new_playback_size ;
			mBufferSize = mPlaybackSize ;
			TBRecord->Max = mPlaybackSize - mWindow ;
			file->Read( mPlaybackBuffer, new_playback_size ) ;
			delete file ;
			TBRecord->Position = 0 ;
			TBRecordChange( this ) ;
			Caption = OpenDialog1->FileName ;
		}
		catch ( ... )
		{
			ShowMessage("The file cannot be opened!") ;
		}
	};
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NewClick(TObject *Sender)
{
	int new_size = 10 * WaveDevice1->WaveInAvgBytesPerSec ;
	void *playback_buffer = realloc( mPlaybackBuffer, new_size ) ;
	if( playback_buffer == NULL )
	{
		ShowMessage("memory allocation error!") ;
		return ;
	}
	SBStopClick( this ) ;
	mPlaybackBuffer = (char *) playback_buffer ;
	mPlaybackSize = 0 ;
	mBufferSize = new_size ;
	mWindow = 4000 * WaveDevice1->WaveInChannels ;
	TBRecord->Max = 0 ;
	TBRecord->Position = 0 ;
	mPosition = 0 ;
	Caption = "RAW Recorder" ;
	SBPlay->Enabled = false ;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SaveAsClick(TObject *Sender)
{
	if( SaveDialog1->Execute() )
	{
		SBStopClick( this ) ;
		try
		{
			TFileStream *file = new TFileStream( SaveDialog1->FileName, fmCreate ) ;
			file->Write( mPlaybackBuffer, mPlaybackSize ) ;
			delete file ;
			Caption = SaveDialog1->FileName ;
		}
		catch ( ... )
		{
			ShowMessage("The file cannot be saved!") ;
		}
	};
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PaintBoxPaint(TObject *Sender)
{
	static stereo_data *stero_record ;
	static short int *mono_record ;
	static int i, j ;

	PaintBox1->Canvas->Rectangle( 0, 0, 400, 67 ) ;

	if( WaveDevice1->WaveInChannels == 1 )
	{
		mono_record = (short int *)( mPlaybackBuffer + mPosition ) ;

		if(  mPlaybackSize < mPosition + mWindow )
		{
			j = (mPlaybackSize - mPosition)/2 ;
			PaintBox1->Canvas->Rectangle( j / 5, 0, j / 5 + 2, 66 ) ;
		}
		else
		{
			j = 2000 ;
		}

		PaintBox1->Canvas->MoveTo( 0, 34 ) ;
		for( i = 0 ; i < j ; i++ )
		{
			PaintBox1->Canvas->LineTo( i / 5, 34 + mono_record[i] / 1000 ) ;
		}
	}
	else
	{
		stero_record = (stereo_data *)( mPlaybackBuffer + mPosition ) ;

		PaintBox2->Canvas->Rectangle( 0, 0, 400, 67 ) ;

		if(  mPlaybackSize < mPosition + mWindow )
		{
			j = (mPlaybackSize - mPosition)/4 ;
			PaintBox1->Canvas->Rectangle( j / 5, 0, j / 5 + 2, 66 ) ;
			PaintBox2->Canvas->Rectangle( j / 5, 0, j / 5 + 2, 66 ) ;
		}
		else
		{
			j = 2000 ;
		}

		PaintBox1->Canvas->MoveTo( 0, 34 ) ;
		PaintBox2->Canvas->MoveTo( 0, 34 ) ;
		for( i = 0 ; i < j ; i++ )
		{
			PaintBox1->Canvas->LineTo( i / 5, 34 + stero_record[i].left / 1000 ) ;
			PaintBox2->Canvas->LineTo( i / 5, 34 + stero_record[i].right / 1000 ) ;
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Help1Click(TObject *Sender)
{
	Application->HelpCommand(HELP_CONTENTS, 0) ;
}
//---------------------------------------------------------------------------


